// reset && g++ -I/usr/local/include/opencv -I/usr/local/include/opencv2 -L/usr/local/lib/ -g -o binary  psnr.cc -lopencv_core -lopencv_imgproc -lopencv_highgui -lopencv_imgcodecs

#include <iostream> // for standard I/O
#include <string>   // for strings
#include <iomanip>  // for controlling float print precision
#include <sstream>  // string to number conversion
// OpenCV image processing library
#include <opencv2/opencv.hpp>
#include <vector>
#include <stdlib.h> // Using system functions - /* atoi */
#include <fstream> // Reading from files
using namespace cv;
using namespace std;

string intToString(int integer);

int main()
{
    ifstream inputFile;
    inputFile.open ("auxFile.txt", ifstream::in);

    ofstream outputFile;

    string application_root, originalImages, receivedImages, imageFormat; // sempre pegarei na execucao da aplicacao
    inputFile >> application_root;
    inputFile >> originalImages;
    inputFile >> receivedImages;

    application_root += "/";

    if(originalImages == ""){
        cout << "Using default name to originalImages and receivedImages folders" << endl;
        // Use the default name in case of the user do not provide it
        originalImages = application_root + "originalImages/";
        receivedImages = application_root + "receivedImages/";
    }
    else{
        originalImages = application_root + originalImages;
        originalImages += "/";
        if(receivedImages == ""){
            cout << "Using default name to receivedImages folders" << endl;
            receivedImages = application_root + "receivedImages/";
        }
        else{
            receivedImages = application_root + receivedImages;
            receivedImages += "/";
        }
    }

    cout << "Original: " << originalImages << endl;
    cout << "Received: " << receivedImages << endl << endl;

    inputFile.close();
    
    imageFormat = ".jpg";

    vector <Mat> originalImagesFiles;
    int numImgSource = 0;
    string currentImageName, numImgSourceStr;

    while(true) {
        ostringstream convert;
        convert << numImgSource;
        numImgSourceStr = convert.str();  
        currentImageName = originalImages + numImgSourceStr + imageFormat;
        Mat image = imread(currentImageName.c_str(), IMREAD_UNCHANGED);
        if( image.empty() ) {
            cout <<  "End of originalImages folder. " << endl;
            cout <<  "End indicator: " << currentImageName << endl << endl;
            break;
        }
        else{
            originalImagesFiles.push_back(image);
        }
        numImgSource++;
    }

    
    system( string("ls -1 " + receivedImages + " | wc -l > auxFile.txt").c_str() );

    int numNodes;
    string currentNode;
    Mat analyzedImage, diffImage;

    inputFile.open ("auxFile.txt", ifstream::in);
    inputFile >> numNodes;
    cout << "numNode: " << numNodes << endl;
    inputFile.close();

    outputFile.open("Psnr_Trace.txt");
    for (int i = 1 ; i<=numNodes; i++){
        
        currentNode = intToString(i);
        outputFile << "NODE " << currentNode << "\n";
        system( string("ls -1 " + receivedImages + "/" + currentNode + " > auxFile.txt").c_str() );
        inputFile.open ("auxFile.txt", ifstream::in);
        while ( inputFile >> currentImageName ){
            outputFile << currentImageName << ". PSNR: ";
            string imglocation = receivedImages + "/" + currentNode + "/" + currentImageName;
            analyzedImage = imread(imglocation, IMREAD_UNCHANGED);
            if( analyzedImage.empty() ) {
                 outputFile << "Impossible to read the image \n";
            }
            else{
                try {
                    //namedWindow( imglocation, WINDOW_AUTOSIZE ); // Create a window for display.
                    //imshow( imglocation, analyzedImage );                // Show our image inside it.
                    //waitKey(500); // Wait for a keystroke in the window
                    size_t pos = currentImageName.find("-"); // Get the position of first "-"
                    string subString = currentImageName.substr (0, pos-1);
                    int numOriginalImage = atoi( subString.c_str() );
                    double psnr = PSNR(originalImagesFiles[numOriginalImage], analyzedImage);
                    outputFile << psnr << "\n";
                }
                catch (cv::Exception& e) {
                    outputFile << "corrupted image" << "\n";
                    //system("clear");
                }
                
            }
            outputFile << "\n";
        }
        outputFile << "\n";
        inputFile.close();
    }
    outputFile.close();
    return 0;
}

string intToString(int integer){
    string charArray;
    ostringstream convert;  
    convert << integer;
    charArray = convert.str();  
    return charArray;
}

