// Universidade Estadual de Feira de Santana
// Author: Lucas Vinicius dos Santos Assis
// Class to make traces from image transmission application

#include "ImageTransmissionTraces.h"

// Function to write data of simmulation in output file
// it tries open the visualCastalia output file and then, if successful, stores the trace
void ImageTransmissionTraces::writeTrace(int numNode, double simTime, string infoToTrace) {
	while (true) {
		// It opens an output file , with the output being appended in the end of the file
		trace.open (traceName, fstream::out | fstream::app);
		if( trace.is_open() ){
			trace << "SimTime: " << doubleToString (simTime) << "\t\t";
			trace << " Node: " << intToString (numNode) << "\t";
			trace << " " << infoToTrace << "\n";
			trace.close();
			break;
		}
	}
}

// Convertion of integers numbers to string
string ImageTransmissionTraces::intToString(int integer){
	string charArray;
	ostringstream convert;	
	convert << integer;
	charArray = convert.str();	
	return charArray;
}

// Convertion of doubles numbers to string
string ImageTransmissionTraces::doubleToString(double Double){
	string charArray;
	ostringstream convert;	
	convert << Double;
	charArray = convert.str();	
	return charArray;
}